#
#                             IPSTB Project
#                   ---------------------------------
#
# Copyright (C) 2009 NXP B.V.,
# All Rights Reserved.
#
# Rev Date       Author      Comments
#-------------------------------------------------------------------------------
#   1 20060301   batelaan    Initial
#   2 20060810   batelaan    Added help.first target.
#   3 20061218   batelaan    Ensure help is the default target.
#   4 20070103   batelaan    Unset MAKEFLAGS/MAKEOVERRIDES to prevent unwanted inheritance by sub-makes.
#   5 20070220   batelaan    Add userrc.mk
#   6 20080623   batelaan    Add include of setup_productversion.mk and
#                            site_setup.mk
#   7 20090106   batelaan    Optionally include proprietary.mk

# File: init.mk
# Initialises the make session. Loaded only once from file <first.mk>
#
# Includes:-
# - <util.mk>
# - <setup_productversion.mk>
# - <site_setup.mk>
# - <userrc.mk>
# - <envvars.mk>
# - <package.mk>
# - <module.mk>
# - <sde2.mk>
# - <proprietary.mk> (if it exists)

# Target: default
# Configurable first target.
# By default this is the <help> target.
default: help

# Not set if there are no goals specified:
MAKECMDGOALS?=

# Variable: MAKEOVERRIDES
# Contains the make command line variable definitions. We reset it here to empty
# because by default we don't want to pass anything down to sub-make invocations.
MAKEOVERRIDES=

# Variable: MAKEFLAGS
# Contains the make command line flags and variable definitions. We reset it here to empty
# because by default we don't want to pass anything down to sub-make invocations.
MAKEFLAGS=

# Delete inbuilt stuff we don't use, it wastes file system accesses:
.SUFFIXES:
%:: %,v
%:: RCS/%,v
%:: RCS/%
%:: SCCS/s.%
%:: s.%

# Target: help.first
# Target which is a predecessor of the <help> target.
# By default it doesn't do anything.
help.first::; @:

# Target: help
# Prints help information on how to use the makefiles.
help:: help.first
	@echo 'To see which targets there are, execute "make <package>" - possible <package> values:'
	@echo '  $(ALLPKGS)'
	@echo 'In general, targets are "<package>.<target>" - possible <target> values:'
	@echo '  $(EXTPKGSTDTARGETS)'
	@echo; echo 'Other targets:'

include $(PRJROOT)/etc/util.mk
include $(PRJROOT)/etc/setup_productversion.mk
include $(PRJROOT)/etc/userrc.mk
include $(PRJROOT)/etc/site_setup.mk
help.util:: help.userrc
include $(PRJROOT)/etc/envvars.mk
include $(PRJROOT)/etc/package.mk
include $(PRJROOT)/etc/module.mk
include $(PRJROOT)/etc/sde2.mk
-include $(PRJROOT)/etc/proprietary.mk
