#
#                             IPSTB Project
#                   ---------------------------------
#
# Copyright (C) 2009 NXP B.V.,
# All Rights Reserved.
#
# Filename: toolchains/tuxbuilder-1.4.mk
#
# Rev Date        Author      Comments
#-------------------------------------------------------------------------------
#   1 20080306    batelaan    Initial
#   2 20090323    steel       update for uclibc

# File: tuxbuilder-1.4.mk
# Include makefile to define the tuxbuilder-1.4 MIPS toolchain.
# It uses uclibc.
# Defines variable <toolchain/mips.env>.
#
# Included from:-
# - <platforms.mk>.
# - <platform_dsp_cpu.mk> or
# - <platform_control_cpu.mk>
#
# Includes:-
# - <toolchains/tuxbuilder_common.mk>

TUXBUILDER_VERSION = 1.4
TUXBUILDER_TYPE = mipsel-unknown-linux-uclibcgnu

ifdef CPUBUILDROOT
  CROSS_COMPILE_LIBC = libc.so.0
  CROSS_COMPILE_LIB_FILES = \
    ld-uClibc.so.0 \
    libc.so.0 \
    libcrypt.so \
    libdl.so \
    libgcc_s.so \
    libm.so \
    libnsl.so \
    libpthread.so \
    libresolv.so \
    librt.so \
    libstdc++.so \
    libutil.so
endif
include etc/toolchains/tuxbuilder_common.mk
