#.      COPYRIGHT (c) 2008 NXP Semiconductors
# All Rights Reserved.
#
# Filename: manifest.mk
#
# Manifest info generation.
# For use with the tmmanifest program from STB225.
#
# - Generates a _manifest_generated.c file
# - Compiles it, and adds it to a dll or application.

# It is not needed that changes to this file force rebuilds of everything:
#_SDE_DEP_MAKEFILES += $(_TMROOT)/project/manifest.mk

#-----------------------------------------------------------------------
# Manifest (MODULE_INFO) Handling
#-----------------------------------------------------------------------

# Only generate manifest using info if we are building
# a dll or an application.
ifneq "$(_SDE_THISDLL)$(filter EXE,$(_SDE_BUILD_TARGET))" ""
  _SDE_MANIFEST_CFILE_DEPS := $(lastword $(MAKEFILE_LIST))
  include $(PRJROOT)/etc/setup_productversion.mk
  _SDE_MANIFEST_CFILE_DEPS += $(PRJROOT)/etc/setup_productversion.mk

  _SDE_MANIFEST_CFILE = $(DIR_INTERM)/_manifest_generated.c
  _SDE_MANIFEST_OFILE = $(_SDE_MANIFEST_CFILE:.c=.$(_SDE_O))
  _SDE_OBJECTS += $(_SDE_MANIFEST_OFILE)
  $(_SDE_MANIFEST_OFILE) : $(_SDE_MANIFEST_CFILE) $(_SDE_DEP_MAKEFILES)
	@$(ECHO) compiling $(notdir $<)
	$(_SDE_ECHO)$(CC) $(_SDE_COPTS) $(TARGET_CFLAGS) -c -o $@ $<

  ifneq "$(_SDE_THISDLL)" ""
    $(_SDE_THISDLL): $(_SDE_MANIFEST_OFILE)
  endif
  ifeq "$(_SDE_BUILD_TARGET)" "EXE"
    $(_SDE_DIR_BIN)/$(TARGET): $(_SDE_MANIFEST_OFILE)
  endif

  $(_SDE_MANIFEST_CFILE): $(_SDE_MANIFEST_CFILE_DEPS)
	$(_SDE_ECHO)$(MKDIR) $(dir $(_SDE_MANIFEST_CFILE))
	$(_SDE_ECHO)$(ECHO) '#define __sde2_stringify_1(x) #x' >$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '#define __sde2_stringify(x) __sde2_stringify_1(x)' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '#define ___sde2_module_cat(a,b) __mod_ ## a ## b' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '#define __sde2_module_cat(a,b) ___sde2_module_cat(a,b)' >>$(_SDE_MANIFEST_CFILE)
	$(_SDE_ECHO)$(ECHO) '#define _SDE2_MODULE_INFO(name,value) \
static const char __sde2_module_cat(name,__LINE__)[]				  \
 __attribute__((__used__)) \
 __attribute__((section(".modinfo"),unused)) = __sde2_stringify(name) "=" value \
' >>$(_SDE_MANIFEST_CFILE)
	$(_SDE_ECHO)$(ECHO) '_SDE2_MODULE_INFO(productversion, "$(PRODUCTVERSION)");' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '_SDE2_MODULE_INFO(builddate, __DATE__);' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '_SDE2_MODULE_INFO(buildtime, __TIME__);' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '_SDE2_MODULE_INFO(builduser, "$(firstword $(LOGNAME) $(USER))");' >>$(_SDE_MANIFEST_CFILE);\
	$(ECHO) '_SDE2_MODULE_INFO(buildhost, "$(shell hostname)");' >>$(_SDE_MANIFEST_CFILE)

endif
