# Copyright (C) 2007 NXP B.V.,
# All Rights Reserved.
#
# Filename: $_TMROOT/project/project_include.mk
#
# Included from $_TMROOT/sde/common.mk
#
# Rev Date       Author      Comments
#-------------------------------------------------------------------------------
#   1 20060622   batelaan    Initial
#   2 20061025   batelaan    Add varutil.mk include
#   3 20070907   batelaan    Make prjconfig.h generally available.
#   4 20071009   batelaan    Add print_required_interfaces
#   5 20071026   batelaan    Add examine_vars
#   6 20071218   batelaan    Ensure configuration target is always called.

_SDE_DEP_MAKEFILES += $(_TMROOT)/project/project_include.mk

-include $(_TMROOT)/project/$(DIR_CONFIG)_include.mk

include $(PRJROOT)/etc/varutil.mk
help: help.varutil

# Try to work out predefined macros:
cc.defs:
	touch /tmp/cc.defs.h
	$(_SDE_ECHO)$(CC) $(_SDE_PROC_DEFINES) $(TARGET_CFLAGS) -E -Wp,-dM /tmp/cc.defs.h >$(PRJROOT)/sde2.cppdefs
	@$(ECHO) See $(PRJROOT)/sde2.cppdefs

# Copy "<BUILDROOT>/prjconfig.h" to "$(_SDE_DIR_LIB)/prjconfig.h".
# This is a global file that needs to be available
# without components having to specify DIR_INCLUDE += $(<BUILDROOT>).
# Note: $(_SDE_DIR_LIB) already contains configuration-specific files,
# like tmFlags.h .
kmodule_lib_build kmodule _SDE_BIN_REL_LIB: configuration
configuration:: $(_SDE_DIR_LIB)/prjconfig.h
$(_SDE_DIR_LIB)/prjconfig.h: $(BUILDROOT)/prjconfig.h
	$(_SDE_ECHO)$(CP) -f $< $@

#-----------------------------------------------------------------------
# INFORMATION
#-----------------------------------------------------------------------

# Target: print_required_interfaces
# Print <_SDE_REQUIRED_INTERFACES> value, one item per line, to file descriptor 3.
print_required_interfaces:
	@for c in $(_SDE_REQUIRED_INTERFACES); do echo "$$c" 1>&3; done

# Define: _SDE_EXAMINE_VARS
# List of 'interesting' SDE2 variables, that we can print using the target
# <examine_vars>.
_SDE_EXAMINE_VARS := \
	BINARY_RELEASE_AVAILABILITY \
	CHECK_BINARY_RELEASE_FILES \
	C_SOURCES \
	CYGWINROOT \
	DIR_CONFIG \
	DIR_INCLUDE \
	DIR_INTERM \
	DIR_INTERM_EXE \
	DIR_INTERM_LIB \
	DIR_LOCAL \
	DIR_PROJECT \
	DIR_SDE \
	EXPORTS \
	GLOBAL_DEPENDENTS \
	INSTALL_DIR \
	KMODE_SUFFIX \
	KMODULE_COMPS \
	KMODULE_DEF_FILE \
	KMODULE_INCLUDED_COMPS \
	KMODULE_INCLUDED_LIB_PATHS \
	KMODULE_LIB_EXPORTS_FILE \
	KMODULE_NAME \
	LB \
	LD_DLL \
	LD \
	LIBS \
	LIB_SUFFIX \
	LINTDEFINES \
	LINTINCLUDES \
	LINT \
	LOCAL_CFLAGS \
	LOC_LIST_FILENAME \
	LOC_LIST_MKFILENAME \
	MISSING_BINARY_RELEASE_FILES \
	PRESENT_BINARY_RELEASE_FILES \
	PROVIDES \
	_QMORE_QAC_VIA \
	REL_COMPS_SUFFIX \
	REL_SUFFIX \
	REQUIRES \
	_SDE_A_COMPILE_CMD \
	_SDE_ALL_AOPTS \
	_SDE_ALL_COMPS_DIR \
	_SDE_ALL_COPTS \
	_SDE_ALL_CXXOPTS \
	_SDE_AOPTS_FILE1 \
	_SDE_AOPTS_FILE2 \
	_SDE_AOPTS_FILE3 \
	_SDE_AOPTS \
	_SDE_ARSUFFIX \
	_SDE_AVAILABLE_REQUIRED_INTERFACES \
	_SDE_BUILD_TARGET \
	_SDE_C_COMPILE_CMD_PREV \
	_SDE_C_COMPILE_CMD \
	_SDE_CFLAGS_OS \
	_SDE_CI \
	_SDE_COMPILER_TYPE \
	_SDE_COMP_LIST_DIR \
	_SDE_COMP_LIST_FILE \
	_SDE_COMPS_FILE \
	_SDE_COPTS_FILE1 \
	_SDE_COPTS_FILE2 \
	_SDE_COPTS_FILE3 \
	_SDE_COPTS_FILE4 \
	_SDE_COPTS \
	_SDE_COPYINC_DIR \
	_SDE_CXX_COMPILE_CMD \
	_SDE_CXXOPTS_FILE1 \
	_SDE_CXXOPTS_FILE2 \
	_SDE_CXXOPTS_FILE3 \
	_SDE_CXXOPTS_FILE4 \
	_SDE_CXXOPTS \
	_SDE_DEBUG_OPTIONS \
	_SDE_DEFAULT_PROVIDER \
	_SDE_DEP_DIVERSITY_MAKEFILES \
	_SDE_DEPENDENCIES \
	_SDE_DEP_L_FILES \
	_SDE_DEP_LIBRARIES \
	_SDE_DEP_MAKEFILES \
	_SDE_DIR_BIN_EXTPATH \
	_SDE_DIR_BIN \
	_SDE_DIR_BUILD_ROOT \
	_SDE_DIR_BUILD \
	_SDE_DIR_CONFIG \
	_SDE_DIR_LIB_DEF \
	_SDE_DIR_LIB_EXT_DEF \
	_SDE_DIR_LIB_EXT \
	_SDE_DIR_LIB_LOCAL \
	_SDE_DIR_LIB \
	_SDE_DIRLIB_SUFFIX \
	_SDE_DIR_REL_TO_LOCAL_ROOT \
	_SDE_DIV_DEBUG \
	_SDE_DIVERSITY \
	_SDE_DLL_EXTN \
	_SDE_DLL_LINK_CMD \
	_SDE_DLL_OPTIONS_LAST \
	_SDE_DLL_OPTIONS \
	_SDE_DLL_PREFIX \
	_SDE_DLLS \
	_SDE_DLLTARGETNAME \
	_SDE_DOT_PATH \
	_SDE_END_COMMANDS \
	_SDE_EXT_DLLS \
	_SDE_EXT_LIBS \
	_SDE_EXTRA_AFLAGS \
	_SDE_EXTRA_CFLAGS \
	_SDE_EXTRA_CXXFLAGS \
	_SDE_EXTRA_LBFLAGS \
	_SDE_FLAVOR_OPTIONS \
	_SDE_GCC_AOPTIONS \
	_SDE_GCC_COPTIONS \
	_SDE_GCC_CXXOPTIONS \
	_SDE_HOST_EXE_EXT \
	_SDE_IMPORT_DLLS \
	_SDE_IMPORT_LIBS \
	_SDE_IMPORT_LIBS_REPLACED \
	_SDE_INCLUDES_C \
	_SDE_INCLUDES_CXX \
	_SDE_INCLUDE_SDE_COMMON_MK_ \
	_SDE_INCLUDES \
	SDE_IN_SDE \
	_SDE_INTERFACE \
	_SDE_INTFS_LIST_DIR \
	_SDE_INTFS_LIST_FILE \
	_SDE_LBOPTS \
	_SDE_LD_DEBUG_OPTIONS \
	_SDE_L_DIR \
	_SDE_LDOPTS \
	_SDE_L_FILE \
	_SDE_LIB_CONFIGURATION_DEF \
	_SDE_LIB_CONFIGURATION \
	_SDE_LIBDEV_INCLUDES \
	_SDE_LIB_EXTN \
	_SDE_LIB_LINK_CMD_PREV \
	_SDE_LIB_LINK_CMD \
	_SDE_LIB_PATHS \
	_SDE_LIBRARIES \
	_SDE_LIBS_DIVERSITY \
	_SDE_LIBS_NOSFX \
	_SDE_LINKSTYLE \
	_SDE_LINKWARNING_LEVEL \
	_SDE_LOCAL_LIB_DIR \
	_SDE_MACHINE \
	_SDE_MISSING_INTERFACES \
	_SDE_MISSING_LFILES \
	_SDE_MISSING_REQUIRED_INTERFACES \
	_SDE_OBJECTS \
	_SDE_ONLYSTATICLIB \
	_SDE_O \
	_SDE_OSAPI_INC_DIR \
	_SDE_OTHER_CFG_SOURCES \
	_SDE_OTHER_C_SOURCES \
	_SDE_OTHER_CXX_SOURCES \
	_SDE_OTHER_S_SOURCES \
	_SDE_OUT_LB \
	_SDE_OUT_LD \
	_SDE_PATH_GENERIC_LIBS \
	_SDE_PRJLIST_FILENAME \
	_SDE_PROC_DEFINES \
	_SDE_PROJECT \
	_SDE_PROVIDED_BY_ENTRIES \
	_SDE_PROVIDED_BY_FLAGS \
	_SDE_PROVIDER \
	_SDE_R_DIR \
	_SDE_RECURSE_STATIC_LIBS \
	_SDE_RECURSE_STATIC_LIBS_REPLACED \
	_SDE_RECURSE_STATIC_SFX_LIBS \
	_SDE_REL_OPTION \
	_SDE_REQPRJ \
	_SDE_REQPRJ_DIRS \
	_SDE_REQUIRED_EXTPROJECT_INTERFACES \
	_SDE_REQUIRED_INTERFACES \
	_SDE_REQUIRED_PATH_DLLS \
	_SDE_REQUIRED_PATH_LIBS \
	_SDE_R_FILE \
	_SDE_RGD_COMPNAME \
	_SDE_RGD_H_FILE \
	_SDE_RGD_OUTFILE \
	_SDE_RGD_PREFIX \
	_SDE_SUPPORTED_CONFIGS \
	_SDE_SUPPORTED_CPUTYPES \
	_SDE_SUPPORTED_OSTYPES \
	_SDE_TARGETS_NO_TMFLAGS \
	_SDE_TCS_LIBDEV \
	_SDE_TEMP_MAKEFILES \
	_SDE_THISDLL_ACTUAL \
	_SDE_THISDLL \
	_SDE_THISLIB_ACTUAL \
	_SDE_THISLIB \
	_SDE_TMP_FILES \
	_SDE_TMP_INCLUDES1 \
	_SDE_TMP_INCLUDES2 \
	_SDE_TMTGTBUILDROOT \
	_SDE_TYPES_LIST_DIR \
	_SDE_TYPES_LIST_FILE \
	_SDE_VERSION \
	_SDE_WARNING_LEVEL \
	TARGETNAME \
	TARGET \
	_TMCFGPATH \
	_TMDIVERSITY \
	_TMINCPATH \
	_TMLINKTYPE \
	_TMPROJECT \
	_TMREPORTS \
	_TMROOT \
	_TMSITE \
	_TMTGTBUILDROOT \
	_TMTGTCOPYINC \
	_TMTGTCOPYINCFILES \
	_TMTGTCOPYINCMATCH \
	_TMTGTCPUCLASS \
	_TMTGTCPUTYPE \
	_TMTGTENDIAN \
	_TMTGTOS \
	_TMTGTOSCLASS \
	_TMTGTREL \
	_TMTGTWARNINGS \

# Target: examine_vars
# Print out the list of 'interesting' SDE2 variables <_SDE_EXAMINE_VARS>.
examine_vars: $(_SDE_EXAMINE_VARS:%=%.examine_var)

%.examine_var:
	$(info )
	$(info $*: (origin: $(origin $*)))
	$(info Definition: $(value $*))
	$(info Value:= $($*))

