#-----------------------------------------------------------------------
#.      COPYRIGHT (c) 2006 NXP Semiconductors
#
# sde/common.mk
#
# Description: Defines dependency check rules
#              Defines rules for generating objects
#              Defines rules for making option files
#
# Initial Author: Rogier Wester
# Maintained by : Bjorn Bon
#                 Peter Kazakov
#-----------------------------------------------------------------------


# changes to this file force rebuild
_SDE_DEP_MAKEFILES +=   $(_TMROOT)/sde/divsuffix.mk

# Define new diversity suffixes over here.
# The REL_SUFFIX is used for the component itself. It might be changed in diversity.mk
# The REL_COMPS_SUFFIX is used for the required components. It must not be overriden!
_TMTGTREL ?= retail
_TMTGTENDIAN ?= el

ifeq ($(_TMTGTREL),retail)
REL_SUFFIX         =
REL_COMPS_SUFFIX   =
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_RETAIL -DNDEBUG
else
ifeq ($(_TMTGTREL),ret)
REL_SUFFIX         =
REL_COMPS_SUFFIX   =
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_RETAIL -DNDEBUG
override _TMTGTREL=retail
else
ifeq ($(_TMTGTREL),assert)
REL_SUFFIX         = _a
REL_COMPS_SUFFIX   = _a
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_ASSERT
else
ifeq ($(_TMTGTREL),trace)
REL_SUFFIX         = _t
REL_COMPS_SUFFIX   = _t
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_TRACE
else
ifeq ($(_TMTGTREL),debug)
REL_SUFFIX         = _g
REL_COMPS_SUFFIX   = _g
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_DEBUG
else
ifeq ($(_TMTGTREL),dbg)
REL_SUFFIX         = _g
REL_COMPS_SUFFIX   = _g
_SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_DEBUG
override _TMTGTREL=debug
else
_SDE_ERROR = _TMTGTREL does not have a legal value. Legal values are: debug, trace, assert, retail, dbg, ret
endif
endif
endif
endif
endif
endif

ifeq            ($(_TMTGTENDIAN), be)
override _TMTGTENDIAN=eb
endif
ifeq            ($(_TMTGTENDIAN), le)
override _TMTGTENDIAN=el
endif

ifeq            ($(_TMTGTOS), psostm200)
override _TMTGTOS=psos200
endif

_SDE_ARSUFFIX = $(REL_SUFFIX)
_SDE_FLAVOR_OPTIONS = $(_SDE_REL_OPTION)

#-----------------------------------------------------------------------
# This part is used by build scripts to force build in a different mode.
#-----------------------------------------------------------------------
ifeq (_force_debug,$(filter _force_debug,$(MAKECMDGOALS)))
override REL_SUFFIX=_g
override REL_COMPS_SUFFIX   = _g
override _SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_DEBUG
endif

_force_debug:
	$(_SDE_ECHO)$(ECHO) '$(DIR_LOCAL) is forced to debug mode.'

ifeq (_force_assert,$(filter _force_assert,$(MAKECMDGOALS)))
override REL_SUFFIX=_a
override REL_COMPS_SUFFIX   = _a
override _SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_ASSERT
endif

_force_assert:
	$(_SDE_ECHO)$(ECHO) '$(DIR_LOCAL) is forced to assert mode.'

ifeq (_force_trace,$(filter _force_trace,$(MAKECMDGOALS)))
override REL_SUFFIX=_t
override REL_COMPS_SUFFIX   = _t
override _SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_TRACE
endif

_force_trace:
	$(_SDE_ECHO)$(ECHO) '$(DIR_LOCAL) is forced to trace mode.'

ifeq (_force_retail,$(filter _force_retail,$(MAKECMDGOALS)))
override REL_SUFFIX=
override REL_COMPS_SUFFIX=
override _SDE_REL_OPTION = -DTMFL_REL=TMFL_REL_RETAIL -DNDEBUG
endif

_force_retail:
	$(_SDE_ECHO)$(ECHO) '$(DIR_LOCAL) is forced to retail mode.'
