#***********************************************************************
# (C) 2007: NXP Semiconductors
#
# Generic file for building executables on gnu platform
# support: SDE2 Team
#
#***********************************************************************
_SDE_BUILD_TARGET=EXE

#-----------------------------------------------------------------------
# changes to this file force rebuild
#-----------------------------------------------------------------------
_SDE_DEP_MAKEFILES +=   $(DIR_SDE)/$(_TMTOOLCHAIN)/maketarget.mk

#-----------------------------------------------------------------------
# include common part of the makefile
#-----------------------------------------------------------------------
include $(DIR_SDE)/$(DIR_CONFIG)/common.mk

#-----------------------------------------------------------------------
# The target to build
#-----------------------------------------------------------------------
target: $(_SDE_DIR_BIN)/$(TARGET)

#========================================================================
# Link everything together
#========================================================================
-include $(_SDE_DIR_BIN)/$(TARGET).cmd

_SDE_TARGET_LINK_CMD=$(strip $(LD) $(_SDE_OBJECTS)              \
	      $(_SDE_DLLS)                                      \
	      $(_SDE_EXT_DLLS)                                  \
              -Wl,--start-group                                     \
	      $(_SDE_LIBRARIES)                                 \
	      $(_SDE_EXT_LIBS)                                  \
              -Wl,--end-group                                       \
	      $(_SDE_LIB_PATHS)                                 \
	      $(_SDE_LDOPTS)                                    \
	      $(LINK_FLAGS))

$(_SDE_DIR_BIN)/$(TARGET): \
	$(_SDE_OPTIONFILES)    \
	$(_SDE_CPP_FILES)      \
	$(_SDE_OBJECTS)        \
	$(_SDE_DEP_LIBRARIES)  \
	$(_SDE_DEP_L_FILES)    \
	$(_SDE_DEP_MAKEFILES)
	$(_SDE_ECHO)$(ECHO) Start building target...;           \
	$(ECHO) $@;						\
	$(MKDIR) $(_SDE_DIR_BIN);                               \
	$(ECHO) '_SDE_TARGET_LINK_CMD_PREV:=$(_SDE_TARGET_LINK_CMD)'  > $(_SDE_DIR_BIN)/$(@F).cmd; \
	$(_SDE_TARGET_LINK_CMD) -o $@

#-----------------------------------------------------------------------
# Options for code coverage
#-----------------------------------------------------------------------
ifneq ($(filter gcov,$(MAKECMDGOALS)),)

_SDE_EXTRA_CFLAGS=-fprofile-arcs -ftest-coverage
_SDE_EXTRA_CXXFLAGS=$(_SDE_EXTRA_CFLAGS)
_SDE_EXTRA_AFLAGS=$(_SDE_EXTRA_CFLAGS)
_SDE_EXTRA_LDFLAGS=$(_SDE_EXTRA_CFLAGS)

_SDE_GCOV_FILES = $(C_SOURCES:%.c=$(DIR_INTERM)/%.c.gcov)                   \
                  $(CXX_SOURCES:%.cpp=$(DIR_INTERM)/%.cpp.gcov)             \
                  $(filter %.gcov, $(S_SOURCES:%.s=$(DIR_INTERM)/%.s.gcov)  \
                  $(S_SOURCES:%.S=$(DIR_INTERM)/%.S.gcov)                   \
                  $(S_SOURCES:%.asm=$(DIR_INTERM)/%.asm.gcov))              \
                  $(CFG_SOURCES:%.c=$(DIR_INTERM)/%.c.gcov)

$(_SDE_OBJECTS): FORCE
endif

gcov: $(_SDE_OBJECTS) $(_SDE_DIR_BIN)/$(TARGET) $(_SDE_GCOV_FILES)

$(DIR_INTERM)/%.c.gcov: %.c FORCE
	$(_SDE_ECHO)$(ECHO) "Running $(TARGET)" ;\
	$(_SDE_DIR_BIN)/$(TARGET);\
	if [ -f $(*F).bb ] ;\
	then \
	mv $(*F).bb $(dir $@)/ ;\
	fi ;\
	if [ -f $(*F).bbg ] ;\
	then \
	mv $(*F).bbg $(dir $@)/ ;\
	fi ;\
	if [ -f $(*F).da ] ;\
	then \
	mv $(*F).da $(dir $@)/ ;\
	fi ;\
	$(ECHO) Generating $@ ;\
	$(GCOV) -o $(dir $@) $<;\
	if [ -f $(*F).c.gcov ] ;\
	then \
	mv -f $(*F).c.gcov $@ ;\
	fi ;

ifdef _SDE_TARGET_LINK_CMD_PREV
ifneq ($(sort $(_SDE_TARGET_LINK_CMD)),$(sort $(_SDE_TARGET_LINK_CMD_PREV)))
$(_SDE_DIR_BIN)/$(TARGET):FORCE
endif
endif

clean:: clean_target

FORCE:

#-----------------------------------------------------------------------
# Support for extensions
#-----------------------------------------------------------------------
-include $(DIR_SDE)/$(_TMTGTOSCLASS)/maketarget_ext.mk

$(_SDE_END_COMMANDS)
