#------------------------------------------------------------------------
#              COPYRIGHT (c) NXP Semiconductors 2007
#     All rights are reserved. Reproduction in whole or in part is
#     prohibited without the written consent of the copyright owner.
#
#------------------------------------------------------------------------

#
# !!!!! PC-Lint additions !!!!!
# There are two variables to be defined, so make sure:
# LINTHOME (which is the pc-lint directory where the lint-nt.exe is.(e.g. c:/pc-lint)
# LINTFILE (This is the configuration file for the pc lint with the .lnt extension(e.g. CastorSW.lnt)
# are defined.

_SDE_DEP_MAKEFILES +=                                                         \
                $(DIR_SDE)/lint.mk

#------------------------------------------------------------------------
# rule for running LINT on the component sources
#------------------------------------------------------------------------
LINTINCLUDES=$(filter -I%,$(_SDE_ALL_COPTS))
LINTDEFINES=$(filter -D%,$(_SDE_ALL_COPTS))
LINT=$(LINTHOME)/LINT-nt.EXE

lint:
ifeq ($(LINTHOME),)
	$(_SDE_ECHO)$(ECHO) "  "
	$(_SDE_ECHO)$(ECHO) "ERROR: LINTHOME environment variable is not set!"
	$(_SDE_ECHO)$(ECHO) "Use(e.g):  set LINTHOME=c:/pc_lint"
	$(_SDE_ECHO)exit 1
endif
ifeq ($(LINTFILE),)
	$(_SDE_ECHO)$(ECHO) "  "
	$(_SDE_ECHO)$(ECHO) "ERROR: LINTFILE environment variable is not set!"
	$(_SDE_ECHO)$(ECHO) "If this variable is not set then PC-Lint will not work properly."
	$(_SDE_ECHO)$(ECHO) "Use(e.g):  set LINTFILE=CastorSW.lnt "
	$(_SDE_ECHO)exit 1
endif
	$(_SDE_ECHO)$(MKDIR) $(DIR_INTERM)/LINT # create an output directory for this component
	-$(_SDE_ECHO)$(RM)  $(DIR_INTERM)/LINT/my.lnt
# set includes and defines in LINT-config
	$(_SDE_ECHO)for d in $(LINTINCLUDES);do $(ECHO) "$${d}" >> $(DIR_INTERM)/LINT/my.lnt;done
	$(_SDE_ECHO)for d in $(LINTDEFINES);do $(ECHO) "$${d}" >> $(DIR_INTERM)/LINT/my.lnt;done
# run LINT
	-$(_SDE_ECHO)for d in $(C_SOURCES); do $(ECHO) Processing: $$d; $(LINT) -b -i$(DIR_INTERM)/LINT -i$(LINTHOME) $(LINTFILE) $$d ; $(ECHO) ; done
