#________________________________________________________________________
# ......................................................................
#.      COPYRIGHT (c) 2006 NXP Semiconductors 
#.     All rights are reserved. Reproduction in whole or in part is     .
#.     prohibited without the written consent of the copyright owner.   .
#
#___________________________________________________________________SCP__

#-----------------------------------------------------------------------
# changes to this file force rebuild
#-----------------------------------------------------------------------

_SDE_DEP_MAKEFILES +=   $(DIR_SDE)/makelib.mk

_SDE_BUILD_TARGET=LIB

_SDE_THISLIB=$(_SDE_DIR_LIB)/$(TARGETNAME)

#-----------------------------------------------------------------------
# include common part of the makefile
#-----------------------------------------------------------------------
include $(DIR_SDE)/$(DIR_CONFIG)/common.mk

ifeq ($(SDE_IN_SDE),.)
_SDE_LOCAL_LIB_DIR       := $(_$(notdir $(DIR_LOCAL))_DIR)/$(_SDE_DIR_LIB_EXT)
else
_SDE_LOCAL_LIB_DIR       := $(_$(notdir $(SDE_IN_SDE))_DIR)/$(DIR_LOCAL)/$(_SDE_DIR_LIB_EXT)
endif

ifndef LD_DLL
LD_DLL = $(LD)
endif

#------------------------------------------------------------------------
# Binary release for the object files
#------------------------------------------------------------------------
ifneq ($(_TMTGTCOPYOBJ),)
_SDE_COPYOBJLIST := $(strip $(foreach obj, $(_SDE_OBJECTS),             \
                      $(foreach copyobj, $(_TMTGTCOPYOBJ),      \
                        $(if $(findstring $(copyobj).$(_SDE_O),$(obj)),$(obj),) \
                      )                                         \
                    ))
ifeq ($(origin _$(notdir $(DIR_LOCAL))_SUFFIX), undefined)
_SDE_LOCAL_OBJ_DIR_EXT   := $(_$(notdir $(DIR_LOCAL))_DIVERSITY)$(REL_COMPS_SUFFIX)
else
_SDE_LOCAL_OBJ_DIR_EXT   := $(_$(notdir $(DIR_LOCAL))_DIVERSITY)$(_$(notdir $(DIR_LOCAL))_SUFFIX)
endif

ifeq ($(_SDE_LOCAL_OBJ_DIR_EXT),)
_SDE_LOCAL_OBJ_DIR_EXT   := .
endif

endif

#------------------------------------------------------------------------
# Default target rule.
#------------------------------------------------------------------------

lib:: _sde_bin_rel
ifneq (,$(strip $(_SDE_OBJECTS)))
  _sde_bin_rel: _SDE_BIN_REL_LIB
  CHECK_BINARY_RELEASE_FILES += $(_SDE_LOCAL_LIB_DIR)/$(TARGETNAME)
  ifdef _SDE_THISDLL
    # If EXPORTS is empty, then DLLs generation is suppressed
    ifneq ($(strip $(EXPORTS)),)
      _sde_bin_rel: _SDE_BIN_REL_DLL
      CHECK_BINARY_RELEASE_FILES += $(firstword $(wildcard $(_SDE_LOCAL_LIB_DIR)/$(_SDE_DIVERSITY)/$(notdir $(_SDE_THISDLL)) $(_SDE_LOCAL_LIB_DIR)/all-diversities/$(notdir $(_SDE_THISDLL))))
    endif
  endif
else
  _sde_bin_rel:
	$(_SDE_ECHO)$(ECHO) "Warning: This component has no source or object files.";
	$(_SDE_ECHO)$(ECHO) "	 Thus we do not generate an object library.";
endif

-include $(DIR_INTERM)/$(notdir $(_SDE_THISLIB)).cmd
_SDE_LIB_LINK_CMD=$(strip $(LB) $(_SDE_LBOPTS))

ifdef _SDE_LIB_LINK_CMD_PREV
ifneq ($(strip $(_SDE_LIB_LINK_CMD)),$(strip $(_SDE_LIB_LINK_CMD_PREV)))
$(_SDE_THISLIB):FORCE
endif
endif

$(_SDE_THISLIB):                                        \
                $(_SDE_OPTIONFILES)                     \
                $(_SDE_INTERFACES)                      \
                $(_SDE_CPP_FILES)                       \
                $(_SDE_DEP_MAKEFILES)                   \
                $(_SDE_OBJECTS)
	$(_SDE_ECHO)$(MKDIR) $(_SDE_DIR_LIB);           \
	$(RM) $@;                                       \
	$(ECHO) Building library $@;                    \
	$(ECHO) '_SDE_LIB_LINK_CMD_PREV:=$(_SDE_LIB_LINK_CMD)' > $(DIR_INTERM)/$(@F).cmd;   \
	$(_SDE_LIB_LINK_CMD) $(_SDE_OUT_LB)$@ $(LOCAL_LBFLAGS_POST_LIB) $(_SDE_OBJECTS)

_SDE_BIN_REL_LIB: $(_SDE_THISLIB) _check_cmdoptions
ifeq ($(_TMTGTCOPYLIB),1)
	$(_SDE_ECHO)$(ECHO) copying the libraries files to $(_SDE_LOCAL_LIB_DIR); \
	$(MKDIR) $(_SDE_LOCAL_LIB_DIR); \
	$(CP) -r $(_SDE_DIR_LIB)/$(TARGETNAME) $(_SDE_LOCAL_LIB_DIR)
endif
ifneq ($(_TMTGTCOPYINC),)
	$(if $(_TMTGTCOPYINCFILES), \
		$(_SDE_ECHO)$(ECHO) copying the include files to $(_SDE_COPYINC_DIR); \
		$(MKDIR) $(_SDE_COPYINC_DIR); \
		$(CP) -fp $(_TMTGTCOPYINCFILES) $(_SDE_COPYINC_DIR) \
	)
endif

# Variable: _TMTGTCOPYINC
# If not empty, then copy all <_TMTGTCOPYINCFILES>,
# to the following directory:-
# - If <_TMTGTCOPYINC> equals 1, then to <_SDE_LOCAL_LIB_DIR>.
# - Otherwise to directory given by <_TMTGTCOPYINC>.

# Variable: _TMTGTCOPYINCMATCH
# List of wildcards that should match included files inside a component
# and its provided interfaces (<PROVIDED_INTERFACES>) to be copied
# when <_TMTGTCOPYINC> is not empty.
# Default value is: inc/*.h inc/*.hxx inc/*.hpp idl/*.idl .
_TMTGTCOPYINCMATCH ?= inc/*.h inc/*.hxx inc/*.hpp idl/*.idl

# Variable: _TMTGTCOPYINCFILES
# Files that should be copied when <_TMTGTCOPYINC> is not empty.
# The default value includes:-
# - <_SDE_RGD_OUTFILE>
# - <_TMTGTCOPYINCMATCH> matches for the component
# - <_TMTGTCOPYINCMATCH> matches for each of the <PROVIDED_INTERFACES>.
# Note: <PROVIDED_INTERFACES> should contain interface names without a starting I character.
# To support transition of a component's inc directory to an interface
# we use both _I{name}_DIR and _{name}_DIR variables to find the interface files.
_TMTGTCOPYINCFILES ?= \
  $(wildcard \
    $(_SDE_RGD_OUTFILE) \
    $(_TMTGTCOPYINCMATCH) \
    $(foreach i,$(PROVIDED_INTERFACES),\
      $(if $(wildcard $(_I$(i)_DIR)/inc $(_I$(i)_DIR)/idl),\
        $(addprefix $(_I$(i)_DIR)/,$(_TMTGTCOPYINCMATCH)), \
        $(addprefix $(_$(i)_DIR)/,$(_TMTGTCOPYINCMATCH)))))

_SDE_COPYINC_DIR = $(if $(filter 1,$(_TMTGTCOPYINC)),$(_SDE_LOCAL_LIB_DIR),$(_TMTGTCOPYINC))

ifneq ($(_SDE_COPYOBJLIST),)
	$(_SDE_ECHO)$(ECHO) copying the object files $(_SDE_COPYOBJLIST) to $(_SDE_LOCAL_LIB_DIR)/$(_SDE_LOCAL_OBJ_DIR_EXT); \
        $(MKDIR) $(_SDE_LOCAL_LIB_DIR)/$(_SDE_LOCAL_OBJ_DIR_EXT); \
        $(CP) -r $(_SDE_COPYOBJLIST) $(_SDE_LOCAL_LIB_DIR)/$(_SDE_LOCAL_OBJ_DIR_EXT);
endif

-include $(DIR_INTERM)/$(notdir $(_SDE_THISDLL)).cmd
_SDE_DLL_LINK_CMD=$(strip $(LD_DLL) $(_SDE_DLL_DEBUG_OPTIONS) $(_SDE_DLL_OPTIONS))

ifdef _SDE_DLL_LINK_CMD_PREV
ifneq ($(strip $(_SDE_DLL_LINK_CMD)),$(strip $(_SDE_DLL_LINK_CMD_PREV)))
$(_SDE_THISDLL):FORCE
endif
endif

$(_SDE_THISDLL): $(_SDE_OBJECTS) \
                $(_SDE_DEP_LIBRARIES)                   \
                $(_SDE_DEP_MAKEFILES)
	$(_SDE_ECHO)$(MKDIR) $(_SDE_DIR_LIB)/$(_SDE_DIVERSITY);   \
	$(RM) $@;                                                 \
	$(ECHO) Building dll $@
	$(_SDE_ECHO)$(ECHO) '_SDE_DLL_LINK_CMD_PREV:=$(subst $(_SDE_SQUOTE),\$(_SDE_SQUOTE),$(_SDE_DLL_LINK_CMD))' > $(DIR_INTERM)/$(@F).cmd
	$(_SDE_ECHO)$(_SDE_DLL_LINK_CMD) $(_SDE_OUT_LD)$@

_SDE_BIN_REL_DLL: $(_SDE_THISDLL) _check_cmdoptions
ifeq ($(_TMTGTCOPYLIB),1)
	$(_SDE_ECHO)$(ECHO) copying the DLL files to $(_SDE_LOCAL_LIB_DIR)/$(_SDE_DIVERSITY); \
	$(MKDIR) $(_SDE_LOCAL_LIB_DIR)/$(_SDE_DIVERSITY); \
        $(CP) -r $(_SDE_DIR_LIB)/$(_SDE_DIVERSITY)/$(_SDE_DLL_PREFIX)$(TARGET).* $(_SDE_LOCAL_LIB_DIR)/$(_SDE_DIVERSITY)
endif

_check_cmdoptions :
ifeq ($(MAKECMDGOALS),_sde_bin_rel)
ifneq ($(_TMTGTCOPYLIB),1)
	@echo 'SDE2 Warning: _TMTGTCOPYLIB not set to 1'
endif
endif

clean:: clean_lib
