#________________________________________________________________________
# ......................................................................
#              COPYRIGHT (c) NXP Semiconductors  2006               .
#.     All rights are reserved. Reproduction in whole or in part is     .
#.     prohibited without the written consent of the copyright owner.   .
# ......................................................................
#
#  %version: SOUsb225#4 % : %date_created: Fri Feb  9 15:42:18 2007 % : %created_by: batelaan % : ... : ...
#
#___________________________________________________________________SCP__
# rule for rgd file building. This makefile is SDE2 add-on
#------------------------------------------------------------------------
#
# xx  20091022  amccurdy  Force update of _SDE_RGD_H_FILE as well as _SDE_RGD_OUTFILE
# xx  20091022  amccurdy  Add _SDE_RGD_NEVER_REBUILD control
#
#------------------------------------------------------------------------

_SDE_RGD_NEVER_REBUILD := true

_SDE_DEP_MAKEFILES += $(DIR_SDE)/rgd.mk

#------------------------------------------------------------------------
ifeq ($(_SDE_RGD_NEVER_REBUILD),true)
#------------------------------------------------------------------------

.PHONY: rgd
rgd:

#------------------------------------------------------------------------
else
#------------------------------------------------------------------------

_SDE_RGD_H_FILE = $(RGD_FILE:%.rgd=%.h)
_SDE_RGD_OUTFILE = $(addprefix $(_SDE_DIR_LIB)/,$(notdir $(_SDE_RGD_H_FILE)))

ifeq ($(patsubst ph%,ph,$(notdir $(DIR_LOCAL))),ph)
_SDE_RGD_PREFIX = PHFL
else
_SDE_RGD_PREFIX = TMFL
endif
_SDE_RGD_COMPNAME = $(basename $(notdir $(_SDE_RGD_OUTFILE)))

#------------------------------------------------------------------------
# Header file generation done as dependency
#------------------------------------------------------------------------
ifeq ($(filter clean_all clean,$(MAKECMDGOALS)),)
$(_SDE_RGD_OUTFILE):                                                        \
                        $(RGD_FILE)                                         \
                        $(_TMROOT)/sde/rgd/tmhw.rgd                         \
                        $(_TMROOT)/sde/rgd/rgd.awk                          \
                        $(_SDE_DEP_MAKEFILES)
ifeq ($(_SDE_RGD_H_FILE),)
	$(_SDE_ECHO)$(ECHO) RGD_FILE is not set
else
	$(_SDE_ECHO)if [ -f $(RGD_FILE) ] ;                                 \
        then                                                                \
	$(MKDIR) -p $(_SDE_DIR_LIB) ;					    \
            if [ ! -f $(_SDE_RGD_OUTFILE) -o -w $(_SDE_RGD_OUTFILE) ] ;     \
            then                                                            \
                $(ECHO) generating $(_SDE_RGD_OUTFILE);                     \
                (                                                           \
                    $(ECHO) '#include <tmNxTypes.h>';                       \
                    $(ECHO) '#include <phFlags.h>';                         \
                    $(ECHO) '#if ($(_SDE_RGD_PREFIX)_ENDIAN == $(_SDE_RGD_PREFIX)_ENDIAN_BIG)';    \
                     $(GAWK)  -v var=$(_SDE_RGD_COMPNAME) -v var1=$(_SDE_RGD_PREFIX)  \
                        -f $(_TMROOT)/sde/rgd/rgd.awk                         \
                        BigEndian=1                                           \
			$(_TMROOT)/sde/rgd/tmhw.rgd                           \
                        $(RGD_FILE);                                          \
                    $(ECHO);                                                  \
                    $(ECHO) '#else   // ($(_SDE_RGD_PREFIX)_ENDIAN == $(_SDE_RGD_PREFIX)_ENDIAN_BIG)';    \
                     $(GAWK)  -v var=$(_SDE_RGD_COMPNAME) -v var1=$(_SDE_RGD_PREFIX)   \
                        -f $(_TMROOT)/sde/rgd/rgd.awk                         \
                        BigEndian=0                                           \
			$(_TMROOT)/sde/rgd/tmhw.rgd                           \
                        $(RGD_FILE);                                          \
                    $(ECHO);                                                  \
                    $(ECHO) '#endif  // ($(_SDE_RGD_PREFIX)_ENDIAN == $(_SDE_RGD_PREFIX)_ENDIAN_BIG)';    \
                ) > $(_SDE_RGD_OUTFILE);                                      \
                                                                              \
                cp $(_SDE_RGD_OUTFILE) $(_SDE_RGD_H_FILE);                    \
                                                                              \
            else                                                              \
                $(ECHO) $(_SDE_RGD_OUTFILE) is not writable;                  \
            fi;                                                               \
        else                                                                  \
            $(ECHO) rgd file $(RGD_FILE) not found;                           \
        fi
endif
endif

#------------------------------------------------------------------------
# Done as an old-style rule
#------------------------------------------------------------------------

rgd: $(_SDE_RGD_OUTFILE)
ifneq ($(RGD_FILE),)
	$(_SDE_ECHO)$(ECHO) "Header file generated from RGD file"
endif

ifneq ($(RGD_FILE),)
$(_SDE_OBJECTS): $(_SDE_RGD_OUTFILE)
endif

#------------------------------------------------------------------------
endif
#------------------------------------------------------------------------

